
#pragma once

// taken from senzee5: http://senzee.blogspot.com/2006/05/c-formatting-stdstring.html

#include <stdio.h>
#include <stdarg.h>
#include <string>

std::string format(const char *fmt, ...);

std::wstring toWideString( const char* pStr , int len );
std::string toNarrowString( const wchar_t* pStr , int len );

/////////////////////////////////////////////////////////////////////////////
//  StringTok<std::string> x( stringA ); 
//  // ...
//  x( delimiters );
template<class T> class StringTokenizer {
public:
   StringTokenizer( const T& seq, typename T::size_type pos = 0 )
       : seq_( seq ) , pos_( pos ) { }
   T operator()( const T& delim );
private:
   const T& seq_;
   typename T::size_type pos_;
};
template<class T> T StringTokenizer<T>::operator() ( const T& delim ) {
   T token;
   if( pos_ != T::npos ) {
      // start of found token
      typename T::size_type first = seq_.find_first_not_of( delim.c_str(), pos_ );
      if( first != T::npos ) {
         // length of found token
         typename T::size_type num = seq_.find_first_of( delim.c_str(), first ) - first;
         // do all the work off to the side
         token = seq_.substr( first, num );    

         // done; now commit using
         // nonthrowing operations only
         pos_ = first+num;                            
         if( pos_ != T::npos ) 
            ++pos_;                
         if( pos_ >= seq_.size() ) 
            pos_ = T::npos; 
      }
   }
   return token;
}
